unit CommReg ;

interface
uses
  DiaLogs,Registry;
  procedure WriteReg(FileName,Key,Values :String);StdCall;
  function ReadReg(FileName,Key:String):String;StdCall;
  procedure DeleteReg(FileName,Key:String);StdCall;

const
    { Reserved Key Handles. }  //ע  
    {$EXTERNALSYM HKEY_CLASSES_ROOT} 
    HKEY_CLASSES_ROOT = $80000000;
    {$EXTERNALSYM HKEY_CURRENT_USER} 
    HKEY_CURRENT_USER = $80000001;
    {$EXTERNALSYM HKEY_LOCAL_MACHINE} 
    HKEY_LOCAL_MACHINE = $80000002;
    {$EXTERNALSYM HKEY_USERS} 
    HKEY_USERS = $80000003;
    {$EXTERNALSYM HKEY_PERFORMANCE_DATA} 
    HKEY_PERFORMANCE_DATA = $80000004;
    {$EXTERNALSYM HKEY_CURRENT_CONFIG} 
    HKEY_CURRENT_CONFIG = $80000005;
    {$EXTERNALSYM HKEY_DYN_DATA} 
    HKEY_DYN_DATA = $80000006;
    
implementation

procedure WriteReg(FileName,Key,Values :String);
var
  WReg :TRegistry;
begin
  WReg :=TRegistry.Create;
  WReg.RootKey :=HKEY_LOCAL_MACHINE;
  try
    if WReg.OpenKey(FileName,True) then
       WReg.WriteString(Key,Values);
  except
    ShowMessage('дע!');
  end;
  WReg.CloseKey;
  WReg.Free;
end;

function ReadReg(FileName,Key:String):String;
var
  RReg :TRegistry;
begin
  RReg :=TRegistry.Create;
  RReg.RootKey := HKEY_LOCAL_MACHINE;
  try
    if RReg.OpenKey(FileName,False) then
       Result :=RReg.ReadString(Key);
  except
    SHowMessage('ȡע!');
  end;
  RReg.CloseKey;
  RReg.Free;
end;

procedure DeleteReg(FileName,Key:String);
var
  DReg :TRegistry;
begin
  DReg :=TRegistry.Create;
  DReg.RootKey := HKEY_LOCAL_MACHINE;
  try
    if DReg.OpenKey(FileName,True) then
       DReg.DeleteValue(Key);
  except
    SHowMessage('ɾע!');
  end;
  DReg.CloseKey;
  DReg.Free;
end;

end.
 